@echo off
setlocal
set CLASSPATH=%CD%;%CLASSPATH%
set JAVAC=javac

if %1. == . goto continue
if %1. == cleanup. goto cleanup
echo Invalid argument "%1". Pass either nothing or 'clean'.
echo Usage: run [no arguments^|clean]
exit /b 1

:continue
echo ASN.1-compiling the syntax...
echo.
asn1pjav dialogue -ber -err dialogue.log
if errorlevel 1 (
    echo Error ASN.1-compiling.
    exit /b 1
) 

if exist "%OSS_ASN1_JAVA%\lib\oss.jar" goto next
echo The environment variable OSS_ASN1_JAVA not set.  Exiting...
exit /b 1

:next
cd dialogue
echo Java-compiling generated classes...
echo.
call dialogue.bat %JAVAC% -g >>..\dialogue.log
cd ..
if not exist myDialogue.ber (
	echo myDialogue.ber not found.
    exit /b 1
)

%JAVAC% -g *.java >>dialogue.log
if not exist External1.class (
    echo Error Java-compiling.
	echo External1.class not found.
    exit /b 1
)

if not exist External2.class (
    echo Error Java-compiling.
	echo External2.class not found.
    exit /b 1
)

if not exist External3.class (
    echo Error Java-compiling.
	echo External3.class not found.
    exit /b 1
)

echo Trying manual decoding of the value of EXTERNAL ...
echo.
java External1
echo Trying manual decoding of the value of EXTERNAL
echo (lookup infomation object set to determine the type of 'encoding')
echo.
java External2
echo Trying automatic decoding of the value of EXTERNAL
echo (EXTERNAL is replaced by the INSTANCE OF)
echo.
java External3

if exist dialogue (
	rmdir /s /q dialogue
    exit /b 0
)

:cleanup
if exist dialogue 	rmdir /s /q dialogue
if exist dialogue.log del dialogue.log
if exist *.class del *.class
