#!/usr/bin/sh
# Please use this script to run the sample. Make sure that you properly set
# up the OSS_ASN1_JAVA, CLASSPATH and PATH environment variables before running
# this script.  You can set up JAVAC and JAVA environment variables to
# customize Java compiler/interpreter.

ACTION=${1:-"javac"}

case ${ACTION} in
    "cleanup")
	rm -fr dialogue
	rm -f dialogue.log
	rm -f *.class
	break;;
	
    "javac")
	CLASSPATH=`pwd`:$CLASSPATH; export CLASSPATH
	JAVAC=${JAVAC:-javac}
	JAVA=${JAVA:-java}
	echo "ASN.1-compiling the syntax..."
	echo ""
	asn1pjav dialogue -ber -err dialogue.log
	if [ $? -eq 0 ]; then 
	    cd dialogue
	    echo "Java-compiling generated classes..."
	    echo ""
	    sh dialogue.sh 2>&1 >> ../dialogue.log
	    cd ..
	    if [ -f myDialogue.ber ]; then
		${JAVAC} External1.java 2>&1 >> dialogue.log
		${JAVAC} External2.java 2>&1 >> dialogue.log
		${JAVAC} External3.java 2>&1 >> dialogue.log
		if [ -f External1.class ]; then
		    echo "Trying manual decoding of the value of EXTERNAL ...";
		    echo ""
		    ${JAVA} External1;
		fi
		if [ -f External2.class ]; then
		    echo "Trying manual decoding of the value of EXTERNAL";
		    echo "(lookup infomation object set to determine the type of 'encoding')";
		    echo ""
		    ${JAVA} External2;
		fi
		if [ -f External3.class ]; then
		    echo "Trying automatic decoding of the value of EXTERNAL";
		    echo "(EXTERNAL is replaced by the INSTANCE OF)";
		    echo ""
		    ${JAVA} External3;
		fi
	    else
		echo "The file 'myDialogue.ber' is not found."
	    fi
	fi
	rm -fr dialogue
	break;;

    *)
	echo "Invalid argument \"$1\"."
	echo ""
	break;;
    
esac
